#include "math.hpp"

#define MAKEINT(R, G, B, A) ((A << 24) | (R << 16) | (G << 8) | B)

using namespace math;

static struct table_entry_t
{
	unsigned char r, g, b, a;
	std::string name;
} rgb_table[] = {
      {240, 248, 255, 255,  "aliceblue" },
      {250, 235, 215, 255,  "antiquewhite" },
      {  0, 255, 255, 255,  "aqua" },
      {127, 255, 212, 255,  "aquamarine" },
      {240, 255, 255, 255,  "azure" },
      {245, 245, 220, 255,  "beige" },
      {255, 228, 196, 255,  "bisque" },
      {  0,   0,   0, 255,  "black" },
      {255, 235, 205, 255,  "blanchedalmond" },
      {  0,   0, 255, 255,  "blue" },
      {138,  43, 226, 255,  "blueviolet" },
      {165,  42,  42, 255,  "brown" },
      {222, 184, 135, 255,  "burlywood" },
      { 95, 158, 160, 255,  "cadetblue" },
      {127, 255,   0, 255,  "chartreuse" },
      {210, 105,  30, 255,  "chocolate" },
      {255, 127,  80, 255,  "coral" },
      {100, 149, 237, 255,  "cornflowerblue" },
      {255, 248, 220, 255,  "cornsilk" },
      {220,  20,  60, 255,  "crimson" },
      {  0, 255, 255, 255,  "cyan" },
      {  0,   0, 139, 255,  "darkblue" },
      {  0, 139, 139, 255,  "darkcyan" },
      {184, 134,  11, 255,  "darkgoldenrod" },
      {169, 169, 169, 255,  "darkgray" },
      {  0, 100,   0, 255,  "darkgreen" },
      {189, 183, 107, 255,  "darkkhaki" },
      {139,   0, 139, 255,  "darkmagenta" },
      { 85, 107,  47, 255,  "darkolivegreen" },
      {255, 140,   0, 255,  "darkorange" },
      {153,  50, 204, 255,  "darkorchid" },
      {139,   0,   0, 255,  "darkred" },
      {233, 150, 122, 255,  "darksalmon" },
      {143, 188, 143, 255,  "darkseagreen" },
      { 72,  61, 139, 255,  "darkslateblue" },
      { 47,  79,  79, 255,  "darkslategray" },
      {  0, 206, 209, 255,  "darkturquoise" },
      {148,   0, 211, 255,  "darkviolet" },
      {255,  20, 147, 255,  "deeppink" },
      {  0, 191, 255, 255,  "deepskyblue" },
      {105, 105, 105, 255,  "dimgray" },
      { 30, 144, 255, 255,  "dodgerblue" },
      {178,  34,  34, 255,  "firebrick" },
      {255, 250, 240, 255,  "floralwhite" },
      { 34, 139,  34, 255,  "forestgreen" },
      {255,   0, 255, 255,  "fuchsia" },
      {220, 220, 220, 255,  "gainsboro" },
      {248, 248, 255, 255,  "ghostwhite" },
      {255, 215,   0, 255,  "gold" },
      {218, 165,  32, 255,  "goldenrod" },
      {128, 128, 128, 255,  "gray" },
      {  0, 128,   0, 255,  "green" },
      {173, 255,  47, 255,  "greenyellow" },
      {240, 255, 240, 255,  "honeydew" },
      {255, 105, 180, 255,  "hotpink" },
      {205,  92,  92, 255,  "indianred" },
      { 75,   0, 130, 255,  "indigo" },
      {255, 255, 240, 255,  "ivory" },
      {240, 230, 140, 255,  "khaki" },
      {230, 230, 250, 255,  "lavender" },
      {255, 240, 245, 255,  "lavenderblush" },
      {124, 252,   0, 255,  "lawngreen" },
      {255, 250, 205, 255,  "lemonchiffon" },
      {173, 216, 230, 255,  "lightblue" },
      {240, 128, 128, 255,  "lightcoral" },
      {224, 255, 255, 255,  "lightcyan" },
      {250, 250, 210, 255,  "lightgoldenrodyellow" },
      {144, 238, 144, 255,  "lightgreen" },
      {211, 211, 211, 255,  "lightgrey" },
      {255, 182, 193, 255,  "lightpink" },
      {255, 160, 122, 255,  "lightsalmon" },
      { 32, 178, 170, 255,  "lightseagreen" },
      {135, 206, 250, 255,  "lightskyblue" },
      {119, 136, 153, 255,  "lightslategray" },
      {176, 196, 222, 255,  "lightsteelblue" },
      {255, 255, 224, 255,  "lightyellow" },
      {  0, 255,   0, 255,  "lime" },
      { 50, 205,  50, 255,  "limegreen" },
      {250, 240, 230, 255,  "linen" },
      {255,   0, 255, 255,  "magenta" },
      {128,   0,   0, 255,  "maroon" },
      {102, 205, 170, 255,  "mediumaquamarine" },
      {  0,   0, 205, 255,  "mediumblue" },
      {186,  85, 211, 255,  "mediumorchid" },
      {147, 112, 219, 255,  "mediumpurple" },
      { 60, 179, 113, 255,  "mediumseagreen" },
      {123, 104, 238, 255,  "mediumslateblue" },
      {  0, 250, 154, 255,  "mediumspringgreen" },
      { 72, 209, 204, 255,  "mediumturquoise" },
      {199,  21, 133, 255,  "mediumvioletred" },
      { 25,  25, 112, 255,  "midnightblue" },
      {245, 255, 250, 255,  "mintcream" },
      {255, 228, 225, 255,  "mistyrose" },
      {255, 228, 181, 255,  "moccasin" },
      {255, 222, 173, 255,  "navajowhite" },
      {  0,   0, 128, 255,  "navy" },
      {253, 245, 230, 255,  "oldlace" },
      {128, 128,   0, 255,  "olive" },
      {107, 142,  35, 255,  "olivedrab" },
      {255, 165,   0, 255,  "orange" },
      {255,  69,   0, 255,  "orangered" },
      {218, 112, 214, 255,  "orchid" },
      {238, 232, 170, 255,  "palegoldenrod" },
      {152, 251, 152, 255,  "palegreen" },
      {175, 238, 238, 255,  "paleturquoise" },
      {219, 112, 147, 255,  "palevioletred" },
      {255, 239, 213, 255,  "papayawhip" },
      {255, 218, 185, 255,  "peachpuff" },
      {205, 133,  63, 255,  "peru" },
      {255, 192, 203, 255,  "pink" },
      {221, 160, 221, 255,  "plum" },
      {176, 224, 230, 255,  "powderblue" },
      {128,   0, 128, 255,  "purple" },
      {255,   0,   0, 255,  "red" },
      {188, 143, 143, 255,  "rosybrown" },
      { 65, 105, 225, 255,  "royalblue" },
      {139,  69,  19, 255,  "saddlebrown" },
      {250, 128, 114, 255,  "salmon" },
      {244, 164,  96, 255,  "sandybrown" },
      { 46, 139,  87, 255,  "seagreen" },
      {255, 245, 238, 255,  "seashell" },
      {160,  82,  45, 255,  "sienna" },
      {192, 192, 192, 255,  "silver" },
      {135, 206, 235, 255,  "skyblue" },
      {106,  90, 205, 255,  "slateblue" },
      {112, 128, 144, 255,  "slategray" },
      {255, 250, 250, 255,  "snow" },
      {  0, 255, 127, 255,  "springgreen" },
      { 70, 130, 180, 255,  "steelblue" },
      {210, 180, 140, 255,  "tan" },
      {  0, 128, 128, 255,  "teal" },
      {216, 191, 216, 255,  "thistle" },
      {255,  99,  71, 255,  "tomato" },
      {  0,   0,   0,   0,  "transparent" },
      { 64, 224, 208, 255,  "turquoise" },
      {238, 130, 238, 255,  "violet" },
      {245, 222, 179, 255,  "wheat" },
      {255, 255, 255, 255,  "white" },
      {245, 245, 245, 255,  "whitesmoke" },
      {255, 255,   0, 255,  "yellow" },
      {154, 205,  50, 255,  "yellowgreen" },
};

Color::Color(const std::string& name): color(-1)
{
}